#ifndef _PWATCH_PROC_H_
#define _PWATCH_PROC_H_

#include "pwatch.h"
#include "pwatch_nl.h"

struct pwatch_fd
{
	struct pwatch_fd	*next;
	int			fd;
	char			file[256];
	unsigned long long	offset;
	unsigned long long	size;
	int			flags;
};

struct pwatch_proc
{
	struct pwatch_proc	*next;

	pid_t			pid;
	char			name[256];

	unsigned long long	speed_read;
	unsigned long long	speed_write;

	unsigned char		version;
	struct timeval		last_set;

	struct pwatch_fd	*fd_head;

	struct taskstats	ts;
};


extern int			pwatch_fdinfo_avail(void);
extern int			pwatch_io_avail(void);

extern struct pwatch_proc	*pwatch_proc_get(struct pwatch_proc *head,
					const pid_t pid);

extern int			pwatch_proc_load_fds(struct pwatch_proc *proc);

extern int			pwatch_proc_load(struct pwatch_proc **head);

extern void			pwatch_proc_dump2file(const struct pwatch_proc *head);

extern void			pwatch_proc_sort(struct pwatch_proc **head,
					const unsigned int sort_by,
					const unsigned int inverse);

extern void			pwatch_proc_clean(struct pwatch_proc **head);

#endif
